<!DOCTYPE html>
<html> 
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title>5 Flüsse</title> 
</head>
<STYLE TYPE="text/css">
	body th, td
	{
		font-family:Arial, sans-serif;
	}
</STYLE>
<body>
<?php

	require "functions.php";
	const showSQL = 1;
	const MaxRow = 3;

	// Verbindung zur Datenbank, sie liegt lokalauf dem Rechner, User ist root, Passwort ist nicht definiert, Name der Datenbank ist hier datenbank
	$conn = new mysqli( 'localhost', 'root','', 'erstedatenbank' );

	if ($conn->connect_error) {
		printf("Verbindungsfehler: %s\n", $conn->connect_error);
		exit();
	}

	// Bei Umlauten ist der korrekte Zeichensatz dringend notwendig!
	$sql_r = $conn->query("SET NAMES 'utf8'");
		
	// die eigentliche Queries
	$sql = "set @var:=1; ";
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b>';

	$sql = "set @kont='' collate utf8_general_mysql500_ci; "; 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b>';

	$sql = ""
			 
		 . "SELECT \n"
		 . "\t T1.Kontinent, \n"
		 . "\t T2.Pos AS Pos, \n"
		 . "\t T1.Name, \n"
		 . "\t T1.Abflussmenge, \n"
		 . "\t T3.MaxPos \n"
		 . "FROM flussliste AS T1, \n(\n"
		 
		 . "\t SELECT \n"
		 . "\t if (@kont=kontinent,@var:=@var+1,@var:=1) as Pos, \n"
		 . "\t name, \n"
		 . "\t @kont:=kontinent \n"
		 . "\t FROM flussliste \n"
		 . "\t ORDER by Kontinent,Abflussmenge desc \n) AS T2, \n"
		 		 
		 . "\t (SELECT \n"
		 . "\t kontinent, \n"
		 . "\t name, \n"
		 . "\t if(count(kontinent)>".MaxRow.",".MaxRow.",count(kontinent)) as MaxPos \n"
		 . "\t FROM flussliste \n"
		 . "\t Group by Kontinent \n"
		 . "\t ORDER by Kontinent,Abflussmenge desc \n) AS T3 \n"
		
		
		 . "WHERE T1.name = T2.name AND T2.pos <= ".MaxRow." "
		 . "AND T1.Kontinent = T3.Kontinent  \n"
		 . "ORDER by T1.Kontinent, T1.Abflussmenge desc \n"
		 
		 . "";
		 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . ws2html($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
	
	$sql_r = $conn->query($sql); 
	// Das Ergebnis der Query wird in Tabellenform ausgegeben, da nicht alle Zeilen und Spalten gleich sind, muss jede Spalte extra ausgeben werden	
	echo $tab.'<tr><th>Kontinent</th><th>Pos</th><th>Name</th><th>Abflussmenge</th></tr>';
	for ($kont='';$sql_row = $sql_r->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		if ($kont!=$sql_row['Kontinent'])
			echo '<td rowspan='.$sql_row['MaxPos'].'>'.$sql_row['Kontinent'].'</td>';			
		echo printNumberORStr($sql_row['Pos']);
		echo printNumberORStr($sql_row['Name']);
		echo printNumberORStr($sql_row['Abflussmenge']);
		$kont=$sql_row['Kontinent'];		
		echo '</tr>';

		echo '<tr>';
	}

	if ($header) echo $tab.'<tr><th>No record found</th></tr>';
	echo $tabClose.'<p>';		

	
	// Die Verbindung zur Datenbank wird beendet	
	$conn->close();


	?>

 </body>
</html>